Index: src/mlx/const.py
===================================================================
--- src/mlx/const.py	(revision 1016)
+++ src/mlx/const.py	(revision 1014)
@@ -12,5 +12,5 @@
 
 ## The version of the program
-VERSION="0.39.7"
+VERSION="0.39.6-py3-1"
 
 #-------------------------------------------------------------------------------
@@ -193,5 +193,5 @@
 def aircraftType2Family(aircraftType):
     """Get the family for the given aircraft type."""
-    for (family, types) in aircraftFamily2Types.iteritems():
+    for (family, types) in aircraftFamily2Types.items():
         if aircraftType in types:
             return family
@@ -424,5 +424,5 @@
 def string2messageLevel(str):
     """Get the message level for the given string."""
-    for (value, s) in _messageLevelStrings.iteritems():
+    for (value, s) in _messageLevelStrings.items():
         if str==s:
             return value
Index: src/mlx/flight.py
===================================================================
--- src/mlx/flight.py	(revision 846)
+++ src/mlx/flight.py	(revision 919)
@@ -1,8 +1,8 @@
 
-from soundsched import SoundScheduler, ChecklistScheduler
-from checks import SpeedChecker
-
-import const
-import util
+from .soundsched import SoundScheduler, ChecklistScheduler
+from .checks import SpeedChecker
+
+from . import const
+from . import util
 import time
 
Index: src/mlx/fs.py
===================================================================
--- src/mlx/fs.py	(revision 909)
+++ src/mlx/fs.py	(revision 919)
@@ -1,10 +1,10 @@
 
-import const
-from sound import startSound
+from . import const
+from .sound import startSound
 
 import os
 
-import fsuipc
-import xplane
+from . import fsuipc
+from . import xplane
 
 import threading
@@ -36,13 +36,13 @@
         """Called when a connection has been established to the flight
         simulator of the given type."""
-        print "fs.ConnectionListener.connected, fsType:", fsType, ", descriptor:", descriptor
+        print("fs.ConnectionListener.connected, fsType:", fsType, ", descriptor:", descriptor)
 
     def connectionFailed(self):
         """Called when the connection could not be established."""
-        print "fs.ConnectionListener.connectionFailed"
+        print("fs.ConnectionListener.connectionFailed")
 
     def disconnected(self):
         """Called when a connection to the flight simulator has been broken."""
-        print "fs.ConnectionListener.disconnected"
+        print("fs.ConnectionListener.disconnected")
 
 #-------------------------------------------------------------------------------
Index: src/mlx/fsuipc.py
===================================================================
--- src/mlx/fsuipc.py	(revision 1018)
+++ src/mlx/fsuipc.py	(revision 1015)
@@ -1,8 +1,8 @@
 
-import fs
-import const
-import util
-import acft
-from watchdog import Watchdog
+from . import fs
+from . import const
+from . import util
+from . import acft
+from .watchdog import Watchdog
 
 import threading
@@ -13,9 +13,10 @@
 import codecs
 import math
+from functools import total_ordering
 
 if os.name == "nt" and "FORCE_PYUIPC_SIM" not in os.environ:
     import pyuipc
 else:
-    import pyuipc_sim as pyuipc
+    from . import pyuipc_sim as pyuipc
 
 #------------------------------------------------------------------------------
@@ -104,6 +105,6 @@
         try:
             return fun()
-        except Exception, e:
-            print >> sys.stderr, util.utf2unicode(str(e))
+        except Exception as e:
+            print(util.utf2unicode(str(e)), file=sys.stderr)
             return None
 
@@ -133,5 +134,5 @@
             try:
                 values = pyuipc.read(data)
-            except TypeError, e:
+            except TypeError as e:
                 exception = e
 
@@ -174,5 +175,5 @@
                 try:
                     pyuipc.write(self._data)
-                except TypeError, e:
+                except TypeError as e:
                     exception = e
 
@@ -197,4 +198,5 @@
                 Handler._callSafe(lambda: self._callback(None, self._extra))
 
+    @total_ordering
     class PeriodicRequest(object):
         """A periodic request."""
@@ -250,8 +252,15 @@
             pass
 
-        def __cmp__(self, other):
-            """Compare two periodic requests. They are ordered by their next
-            firing times."""
-            return cmp(self._nextFire, other._nextFire)
+        def __eq__(self, other):
+            """Equality comparison by the firing times"""
+            return self._nextFire == other._nextFire
+
+        def __ne__(self, other):
+            """Non-equality comparison by the firing times"""
+            return self._nextFire != other._nextFire
+
+        def __lt__(self, other):
+            """Less-than comparison by the firing times"""
+            return self._nextFire < other._nextFire
 
     def __init__(self, connectionListener,
@@ -420,8 +429,8 @@
                 self._connected = True
                 return attempts
-            except Exception, e:
-                print "fsuipc.Handler._connect: connection failed: " + \
+            except Exception as e:
+                print("fsuipc.Handler._connect: connection failed: " + \
                       util.utf2unicode(str(e)) + \
-                      " (attempts: %d)" % (attempts,)
+                      " (attempts: %d)" % (attempts,))
                 if attempts<self.NUM_CONNECTATTEMPTS:
                     time.sleep(self.CONNECT_INTERVAL)
@@ -454,5 +463,5 @@
     def _disconnect(self):
         """Disconnect from the flight simulator."""
-        print "fsuipc.Handler._disconnect"
+        print("fsuipc.Handler._disconnect")
         if self._connected:
             pyuipc.close()
@@ -479,16 +488,16 @@
             try:
                 if not request.process(time):
-                    print "fsuipc.Handler._processRequest: FSUIPC returned invalid data too many times, reconnecting"
+                    print("fsuipc.Handler._processRequest: FSUIPC returned invalid data too many times, reconnecting")
                     needReconnect = True
             except TypeError as e:
-                print "fsuipc.Handler._processRequest: type error: " + \
+                print("fsuipc.Handler._processRequest: type error: " + \
                       util.utf2unicode(str(e)) + \
                       ("." if request.unimportant else
-                       (", reconnecting (attempts=%d)." % (attempts,)))
+                       (", reconnecting (attempts=%d)." % (attempts,))))
                 needReconnect = not request.unimportant
             except Exception as e:
-                print "fsuipc.Handler._processRequest: FSUIPC connection failed (" + \
+                print("fsuipc.Handler._processRequest: FSUIPC connection failed (" + \
                       util.utf2unicode(str(e)) + \
-                      "), reconnecting (attempts=%d)." % (attempts,)
+                      "), reconnecting (attempts=%d)." % (attempts,))
                 needReconnect = True
 
@@ -648,5 +657,4 @@
         self._hotkeyCallback = None
 
-        self._latin1decoder = codecs.getdecoder("iso-8859-1")
         self._fuelCallback = None
 
@@ -723,5 +731,5 @@
         duration is the number of seconds to keep the message displayed."""
 
-        print "fsuipc.Simulator.sendMessage:", message
+        print("fsuipc.Simulator.sendMessage:", message)
 
         if self._scroll:
@@ -731,7 +739,7 @@
 
         try:
-            message = str(message)
-        except Exception, e:
-            print "fsuipc.Simulator.sendMessage: failed to convert the message to a string:", e
+            message = bytes(str(message), "iso-8859-1")
+        except Exception as e:
+            print("fsuipc.Simulator.sendMessage: failed to convert the message to a string:", e)
 
         data = [(0x3380, -1 - len(message), message),
@@ -822,5 +830,5 @@
         assert not self._monitoringRequested
 
-        print "fsuipc.Simulator.disconnect", closingMessage, duration
+        print("fsuipc.Simulator.disconnect", closingMessage, duration)
 
         self._stopNormal()
@@ -887,5 +895,8 @@
         timestamp = Simulator._getTimestamp(data)
 
-        createdNewModel = self._setAircraftName(timestamp, data[5], data[6])
+        aircraftName = str(data[5], "iso-8859-1")
+        aircraftPath = str(data[6], "iso-8859-1")
+
+        createdNewModel = self._setAircraftName(timestamp, aircraftName, aircraftPath)
         if self._fuelCallback is not None:
             self._aircraftModel.getFuel(self._handler, self._fuelCallback)
@@ -946,13 +957,10 @@
 
         Return if a new model was created."""
-        name = self._latin1decoder(name)[0]
-        airPath = self._latin1decoder(airPath)[0]
-
         aircraftName = (name, airPath)
         if aircraftName==self._aircraftName:
             return False
 
-        print "fsuipc.Simulator: new aircraft name and air file path: %s, %s" % \
-              (name, airPath)
+        print("fsuipc.Simulator: new aircraft name and air file path: %s, %s" % \
+              (name, airPath))
 
         self._aircraftName = aircraftName
@@ -1088,13 +1096,14 @@
             self._handler.disconnect()
 
-    def _handleNumHotkeys(self, data, (id, generation)):
+    def _handleNumHotkeys(self, data, hotkeySet):
         """Handle the result of the query of the number of hotkeys"""
+        (id, generation) = hotkeySet
         with self._hotkeyLock:
             if id==self._hotkeySetID and generation==self._hotkeySetGeneration:
                 numHotkeys = data[0]
-                print "fsuipc.Simulator._handleNumHotkeys: numHotkeys:", numHotkeys
+                print("fsuipc.Simulator._handleNumHotkeys: numHotkeys:", numHotkeys)
                 data = [(0x3210 + i*4, "d") for i in range(0, numHotkeys)]
                 self._handler.requestRead(data, self._handleHotkeyTable,
-                                          (id, generation))
+                                          hotkeySet)
 
     def _setupHotkeys(self, data):
@@ -1135,10 +1144,11 @@
 
         for offset in oldHotkeyOffsets:
-            writeData.append((offset, "u", long(0)))
+            writeData.append((offset, "u", int(0)))
 
         return writeData
 
-    def _handleHotkeyTable(self, data, (id, generation)):
+    def _handleHotkeyTable(self, data, hotkeySet):
         """Handle the result of the query of the hotkey table."""
+        (id, generation) = hotkeySet
         with self._hotkeyLock:
             if id==self._hotkeySetID and generation==self._hotkeySetGeneration:
@@ -1146,8 +1156,9 @@
                 self._handler.requestWrite(writeData,
                                            self._handleHotkeysWritten,
-                                           (id, generation))
-
-    def _handleHotkeysWritten(self, success, (id, generation)):
+                                           hotkeySet)
+
+    def _handleHotkeysWritten(self, success, hotkeySet):
         """Handle the result of the hotkeys having been written."""
+        (id, generation) = hotkeySet
         with self._hotkeyLock:
             if success and id==self._hotkeySetID and \
@@ -1158,8 +1169,9 @@
                     self._handler.requestPeriodicRead(0.5, data,
                                                       self._handleHotkeys,
-                                                      (id, generation))
-
-    def _handleHotkeys(self, data, (id, generation)):
+                                                      hotkeySet)
+
+    def _handleHotkeys(self, data, hotkeySet):
         """Handle the hotkeys."""
+        (id, generation) = hotkeySet
         with self._hotkeyLock:
             if id!=self._hotkeySetID or generation!=self._hotkeySetGeneration:
@@ -1397,7 +1409,7 @@
 
         numNotchesM1 = len(self._flapsNotches) - 1
-        flapsIncrement = 16383 / numNotchesM1
+        flapsIncrement = 16383 // numNotchesM1
         flapsControl = data[self._monidx_flapsControl]
-        flapsIndex = flapsControl / flapsIncrement
+        flapsIndex = flapsControl // flapsIncrement
         if flapsIndex < numNotchesM1:
             if (flapsControl - (flapsIndex*flapsIncrement) >
@@ -1406,8 +1418,8 @@
         state.flapsSet = self._flapsNotches[flapsIndex]
         if state.flapsSet != self._flapsSet:
-            print "flapsControl: %d, flapsLeft: %d, flapsRight: %d, flapsAxis: %d, flapsIncrement: %d, flapsSet: %d, numNotchesM1: %d" % \
+            print("flapsControl: %d, flapsLeft: %d, flapsRight: %d, flapsAxis: %d, flapsIncrement: %d, flapsSet: %d, numNotchesM1: %d" % \
                   (flapsControl, data[self._monidx_flapsLeft],
                    data[self._monidx_flapsRight], data[self._monidx_flapsAxis],
-                   data[self._monidx_flapsIncrement], state.flapsSet, numNotchesM1)
+                   data[self._monidx_flapsIncrement], state.flapsSet, numNotchesM1))
             self._flapsSet = state.flapsSet
 
@@ -1588,5 +1600,5 @@
         for (tank, level) in levels:
             offset = _tank2offset[tank]
-            value = long(level * 128.0 * 65536.0)
+            value = int(level * 128.0 * 65536.0)
             data.append( (offset, "u", value) )
 
@@ -1698,7 +1710,8 @@
     """A model handler for the PMDG Boeing 737NG model."""
     @staticmethod
-    def doesHandle(aircraft, (name, airPath)):
+    def doesHandle(aircraft, aircraftName):
         """Determine if this model handler handles the aircraft with the given
         name."""
+        (name, airPath) = aircraftName
         return aircraft.type in [const.AIRCRAFT_B736,
                                  const.AIRCRAFT_B737,
@@ -1730,6 +1743,6 @@
 
         if fsType==const.SIM_MSFSX or fsType==const.SIM_P3D:
-            print "%s detected, adding PMDG 737 NGX-specific offsets" % \
-                  ("FSX" if fsType==const.SIM_MSFSX else "P3D",)
+            print("%s detected, adding PMDG 737 NGX-specific offsets" % \
+                  ("FSX" if fsType==const.SIM_MSFSX else "P3D",))
             self._addOffsetWithIndexMember(data, 0x6500, "b",
                                            "_pmdgidx_lts_positionsw")
@@ -1741,5 +1754,5 @@
             self._addOffsetWithIndexMember(data, 0x65cd, "b", "_pmdgidx_xpdr")
         else:
-            print "FS9 detected, adding PMDG 737 NG-specific offsets"
+            print("FS9 detected, adding PMDG 737 NG-specific offsets")
             self._addOffsetWithIndexMember(data, 0x6202, "b", "_pmdgidx_switches")
             self._addOffsetWithIndexMember(data, 0x6216, "b", "_pmdgidx_xpdr")
@@ -1786,5 +1799,5 @@
 
         if gearControl!=self._lastGearControl or noseGear!=self._lastNoseGear:
-            print "gearControl:", gearControl, " noseGear:", noseGear
+            print("gearControl:", gearControl, " noseGear:", noseGear)
             self._lastGearControl = gearControl
             self._lastNoseGear = noseGear
@@ -1833,7 +1846,8 @@
     """Model handler for the Dreamwings Dash 8-Q400."""
     @staticmethod
-    def doesHandle(aircraft, (name, airPath)):
+    def doesHandle(aircraft, aircraftName):
         """Determine if this model handler handles the aircraft with the given
         name."""
+        (name, airPath) = aircraftName
         return aircraft.type==const.AIRCRAFT_DH8D and \
             (name.find("Dreamwings")!=-1 or airPath.find("Dreamwings")!=-1) and \
@@ -1870,7 +1884,8 @@
     """Model handler for the Majestic Dash 8-Q400."""
     @staticmethod
-    def doesHandle(aircraft, (name, airPath)):
+    def doesHandle(aircraft, aircraftName):
         """Determine if this model handler handles the aircraft with the given
         name."""
+        (name, airPath) = aircraftName
         return aircraft.type==const.AIRCRAFT_DH8D and \
             (name.find("MJC8Q400")!=-1 or \
@@ -1948,7 +1963,8 @@
     """Model for the Digital Aviation F70 implementation on FS9."""
     @staticmethod
-    def doesHandle(aircraft, (name, airPath)):
+    def doesHandle(aircraft, aircraftName):
         """Determine if this model handler handles the aircraft with the given
         name."""
+        (name, airPath) = aircraftName
         return aircraft.type == const.AIRCRAFT_F70 and \
                (airPath.endswith("fokker70_2k4_v4.1.air") or
@@ -2137,8 +2153,9 @@
     """Project Tupolev Tu-154."""
     @staticmethod
-    def doesHandle(aircraft, (name, airPath)):
+    def doesHandle(aircraft, aircraftName):
         """Determine if this model handler handles the aircraft with the given
         name."""
-        print "PTT154Model.doesHandle", aircraft.type, name, airPath
+        (name, airPath) = aircraftName
+        print("PTT154Model.doesHandle", aircraft.type, name, airPath)
         return aircraft.type==const.AIRCRAFT_T154 and \
                (name.find("Tu-154")!=-1 or name.find("Tu154B")!=-1) and \
Index: src/mlx/gui/acars.py
===================================================================
--- src/mlx/gui/acars.py	(revision 747)
+++ src/mlx/gui/acars.py	(revision 996)
@@ -1,9 +1,9 @@
 
-from common import *
+from .common import *
 
 from mlx.i18n import xstr
 import mlx.const as const
 
-import cef
+from . import cef
 
 #------------------------------------------------------------------------------
@@ -18,5 +18,5 @@
 #------------------------------------------------------------------------------
 
-class ACARS(gtk.VBox):
+class ACARS(Gtk.VBox):
     """The flight info tab."""
     # The URL of the ACARS map
Index: src/mlx/gui/bugreport.py
===================================================================
--- src/mlx/gui/bugreport.py	(revision 492)
+++ src/mlx/gui/bugreport.py	(revision 999)
@@ -1,4 +1,4 @@
 
-from common import *
+from .common import *
 
 from mlx.i18n import xstr
@@ -18,5 +18,5 @@
 #------------------------------------------------------------------------------
 
-class BugReportDialog(gtk.Dialog):
+class BugReportDialog(Gtk.Dialog):
     """The dialog to report a bug."""
     def __init__(self, gui):
@@ -24,8 +24,8 @@
                                               xstr("bugreport_title"),
                                               gui.mainWindow,
-                                              DIALOG_MODAL)
+                                              Gtk.DialogFlags.MODAL)
 
-        self.add_button(xstr("button_cancel"), RESPONSETYPE_REJECT)
-        self._sendButton = self.add_button(xstr("button_send"), RESPONSETYPE_ACCEPT)
+        self.add_button(xstr("button_cancel"), Gtk.ResponseType.REJECT)
+        self._sendButton = self.add_button(xstr("button_send"), Gtk.ResponseType.ACCEPT)
         self._sendButton.set_can_default(True)
         self._gui = gui
@@ -33,5 +33,5 @@
         contentArea = self.get_content_area()
 
-        contentAlignment = gtk.Alignment(xalign = 0.5, yalign = 0.5,
+        contentAlignment = Gtk.Alignment(xalign = 0.5, yalign = 0.5,
                                          xscale = 0.0, yscale = 0.0)
         contentAlignment.set_padding(padding_top = 4, padding_bottom = 16,
@@ -40,8 +40,8 @@
         contentArea.pack_start(contentAlignment, False, False, 0)
 
-        contentVBox = gtk.VBox()
+        contentVBox = Gtk.VBox()
         contentAlignment.add(contentVBox)
 
-        label = gtk.Label(xstr("bugreport_summary"))
+        label = Gtk.Label(xstr("bugreport_summary"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
@@ -49,5 +49,5 @@
         contentVBox.pack_start(label, False, False, 4)
 
-        self._summary = summary = gtk.Entry()
+        self._summary = summary = Gtk.Entry()
         summary.connect("changed", self._summaryChanged)
         summary.set_tooltip_text(xstr("bugreport_summary_tooltip"))
@@ -56,5 +56,5 @@
         contentVBox.pack_start(summary, True, True, 4)
 
-        label = gtk.Label(xstr("bugreport_description"))
+        label = Gtk.Label(xstr("bugreport_description"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
@@ -62,24 +62,25 @@
         contentVBox.pack_start(label, False, False, 4)
 
-        self._description = description = gtk.TextView()
+        self._description = description = Gtk.TextView()
         description.set_tooltip_text(xstr("bugreport_description_tooltip"))
-        description.set_wrap_mode(WRAP_WORD)
+        description.set_wrap_mode(Gtk.WrapMode.WORD)
         label.set_mnemonic_widget(description)
 
-        scrolledWindow = gtk.ScrolledWindow()
+        scrolledWindow = Gtk.ScrolledWindow()
         scrolledWindow.add(description)
         scrolledWindow.set_size_request(-1, 200)
-        scrolledWindow.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
-        scrolledWindow.set_shadow_type(SHADOW_IN)
+        scrolledWindow.set_policy(Gtk.PolicyType.AUTOMATIC,
+                                  Gtk.PolicyType.AUTOMATIC)
+        scrolledWindow.set_shadow_type(Gtk.ShadowType.IN)
 
-        alignment = gtk.Alignment(xalign = 0.5, yalign = 0.0, xscale = 1.0, yscale = 1.0)
+        alignment = Gtk.Alignment(xalign = 0.5, yalign = 0.0, xscale = 1.0, yscale = 1.0)
         alignment.add(scrolledWindow)
 
         contentVBox.pack_start(alignment, True, True, 4)
 
-        emailBox = gtk.HBox()
+        emailBox = Gtk.HBox()
         contentVBox.pack_start(emailBox, False, False, 4)
 
-        label = gtk.Label(xstr("bugreport_email"))
+        label = Gtk.Label(xstr("bugreport_email"))
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
@@ -87,8 +88,8 @@
         emailBox.pack_start(label, False, False, 0)
 
-        alignment = gtk.Alignment()
+        alignment = Gtk.Alignment()
         emailBox.pack_start(alignment, False, False, 8)
 
-        self._email = email = gtk.Entry()
+        self._email = email = Gtk.Entry()
         email.set_tooltip_text(xstr("bugreport_email_tooltip"))
         label.set_mnemonic_widget(email)
@@ -105,6 +106,6 @@
         response = super(BugReportDialog, self).run()
 
-        print "response", response, RESPONSETYPE_ACCEPT
-        if response==RESPONSETYPE_ACCEPT:
+        print("response", response, Gtk.ResponseType.ACCEPT)
+        if response==Gtk.ResponseType.ACCEPT:
             self._send()
         else:
@@ -126,9 +127,8 @@
                                      descriptionBuffer.get_end_iter(),
                                      False)
-        description = text2unicode(description)
         self.set_sensitive(False)
-        self._gui.sendBugReport(text2unicode(self._summary.get_text()),
+        self._gui.sendBugReport(self._summary.get_text(),
                                 description,
-                                text2unicode(self._email.get_text()),
+                                self._email.get_text(),
                                 self._bugReportSent)
 
